﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Text;
using System.Web;

namespace ValutaserviceWebApp
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "ValutaService" in code, svc and config file together.
    // NOTE: In order to launch WCF Test Client for testing this service, please select ValutaService.svc or ValutaService.svc.cs at the Solution Explorer and start debugging.
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Required)]
    public class ValutaService : IValutaService
    {
        private static List<Valuta> _valutaListe = new List<Valuta>();
        // istedet for en static variabel kunne man her også lave en property og 
        // så lade denne bruge HttpContext.Current.Application["valutaliste"]
        // på samme måde som SessionValutaliste nedenfor - listen vil så være for alle


        private static object _Listelock = new object();
        static ValutaService()
        {
            _valutaListe.Add(new Valuta("EUR", "EURO", 745));
            _valutaListe.Add(new Valuta("DKK", "Danmark", 10));
        }

        // eksempel på en mulig løsning på at hver klient har egen liste er
        // som en property tilgang og sen session variabel "bag ved" til at sikre "overlevelse"
        // sålænge klienten har en session igang
        private List<Valuta> SessionValutaliste
        {
            get
            {
                if (HttpContext.Current.Session["valutaliste"] == null)
                {
                    List<Valuta> vl = new List<Valuta>();
                    vl.Add(new Valuta("EUR", "EURO", 745));
                    vl.Add(new Valuta("DKK", "Danmark", 10));
                    HttpContext.Current.Session["valutaliste"] = vl;
                    return vl;
                }
                else
                {
                    return HttpContext.Current.Session["valutaliste"]
                        as List<Valuta>;
                }
            }
        }


        public void DoWork()
        {
        }


        public double Konverter(string isoFra, string isoTil, double beløb)
        {
            Valuta fra = new Valuta("EUR", "", 745);
            Valuta til = new Valuta("DKK", "", 100);
            return (fra.Kurs/til.Kurs) * beløb;
        }



        public List<Valuta> HentAlleValutaer()
        {
            //List<Valuta> l = new List<Valuta>();
            //l.Add(new Valuta("EUR", "EURO", 745));
            //l.Add(new Valuta("DKK", "Danmark", 10));
            //return l;
            return _valutaListe;
        }

        public Valuta HentValuta(string iso)
        {
            //Valuta v = new Valuta("EUR", "EURO", 745);
            //return v;
            lock (_Listelock)
            {
                foreach (Valuta v in _valutaListe)
                {
                    if (v.ISO == iso)
                        return v;
                }
                return null;
            }
        }


        public bool OpretValuta(string iso, string land, double kurs)
        {
            lock (_Listelock)
            {
                Valuta ny = new Valuta(iso, land, kurs);
                _valutaListe.Add(ny);
                return true;
            }
        }
    }
}
